package package_vue;


import java.awt.Color;
import java.awt.GridBagConstraints;
import java.util.ArrayList;

import javax.swing.JLabel;
import javax.swing.JSeparator;
import javax.swing.border.LineBorder;

import package_controleur.Controleur;

@SuppressWarnings("serial")
public class PanneauFichiers extends Panneau
{
	private JLabel lblFichiers = new JLabel("FICHIERS");
	private JLabel lblNomFichier = new JLabel("Nom du fichier");
	private JLabel lblDateFichier = new JLabel("Date d'ajout");
	private JLabel lblTailleFichier = new JLabel("Taille");
	private ArrayList<FichierVue> lstFichiers = new ArrayList<FichierVue>();
	private Controleur controleur;
	public PanneauFichiers(Controleur c)
	{
		controleur = c;
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.anchor = GridBagConstraints.LINE_START;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        //gbc.weightx = 1;
        //gbc.insets = new Insets(0,50,0,0);
        lblFichiers.setFont(Panneau.POLICE18b);
        add(lblFichiers, gbc);
        //gbc.weightx = 0;
        
        
        gbc = new GridBagConstraints();
        
        
        // Header Listing Fichiers
    	gbc.gridy = 1;
    	gbc.gridx = 0;
        add(lblNomFichier, gbc);
        gbc.gridx = 1;
        
        gbc.weightx = 1;
        add(lblDateFichier, gbc);
        gbc.weightx = 0;
        
        gbc.gridx = 2;
       // gbc.weightx = 1;
        //gbc.anchor = GridBagConstraints.LINE_END;
        //gbc.fill = GridBagConstraints.HORIZONTAL;
        //lblTailleFichier.setBackground(Color.BLACK);
        add(lblTailleFichier, gbc);
        
        // Separateur Listing Fichiers
        JSeparator sep = new JSeparator(JSeparator.HORIZONTAL);
        sep.setBorder(new LineBorder(new Color(100,100,100), 12));
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.gridx = 0;
        gbc.gridy = 2;
        add(sep, gbc);
	}
	public void rafraichir()
	{
		getParent().getParent().validate();
	}
	public void vider()
	{
		for(FichierVue f : lstFichiers)
		{
			remove(f.nom);
			remove(f.date);
			remove(f.taille);
		}
		lstFichiers.clear();
		rafraichir();
	}
	public int taille() { return lstFichiers.size(); }
	public void ajouter(String nom, String date, String taille)
	{
    	JLabel lblNom = new JLabel(nom);
    	JLabel lblDate = new JLabel(date);
    	JLabel lblTaille = new JLabel(taille);
    	gbc = new GridBagConstraints();
    	gbc.gridy = lstFichiers.size() + 3;
    	gbc.anchor = GridBagConstraints.LINE_START;
        add(lblNom, gbc);
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.weightx = 1;
        add(lblDate, gbc);
        gbc.weightx = 0;
        gbc.anchor = GridBagConstraints.LINE_END;
        add(lblTaille, gbc);
        lstFichiers.add(new FichierVue(lblNom,lblDate,lblTaille));
        rafraichir();
	}
}
