package package_vue;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JSeparator;
import javax.swing.border.LineBorder;

import package_controleur.Controleur;

@SuppressWarnings("serial")
public class PanneauListing extends Panneau
{
	public PanneauTags panneauTags;
	public PanneauFichiers panneauFichiers;
	private Controleur controleur;
	
	public PanneauListing(Controleur c)
	{
		controleur = c;
		panneauTags = new PanneauTags(controleur);
		panneauFichiers = new PanneauFichiers(controleur);

		
		// Panneau Tags
		gbc.insets = new Insets(0,20,0,0);
        add(panneauTags, gbc);
        
        // Separateur
        gbc.gridx = 1;
        JSeparator sep = new JSeparator(JSeparator.VERTICAL);
        sep.setBorder(new LineBorder(new Color(100,100,100), 12));
        gbc.fill = GridBagConstraints.VERTICAL;
        gbc.gridheight = GridBagConstraints.REMAINDER;
        add(sep, gbc);
        
        // Panneau Fichiers
        gbc.weightx = 1;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.insets = new Insets(0,18,0,20);
        gbc.anchor = GridBagConstraints.FIRST_LINE_START;
        gbc.gridx = 2;
        add(panneauFichiers, gbc);
	}
}
