package package_vue;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JTextField;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;

import package_controleur.Controleur;


@SuppressWarnings("serial")
public class PanneauRecherche extends Panneau {
	public JTextField txtRecherche = new JTextField("Recherche");
	public JButton btnRecherche = new JButton(new ImageIcon("loupe.png"));//+fond.jpg
	//public Panneau panRecherche = new Panneau();
	private Controleur controleur;
	public void rafraichir()
	{
		//getParent().validate();
		
		getParent().repaint();
	}
    public PanneauRecherche(Controleur c)
    {
    	controleur = c;
    	btnRecherche.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controleur.rechercher(txtRecherche.getText());
			}
    	});
	    txtRecherche.addCaretListener(new CaretListener(){
			public void caretUpdate(CaretEvent e) {  rafraichir(); }
		});
	    txtRecherche.addKeyListener(new KeyListener(){
			public void keyPressed(KeyEvent e) {
				if (e.getKeyCode() == 10) controleur.rechercher(txtRecherche.getText());
			}
			public void keyReleased(KeyEvent e) { }
			public void keyTyped(KeyEvent e) { }
		});
	    txtRecherche.addMouseMotionListener(new MouseMotionListener(){
			public void mouseDragged(MouseEvent arg0) { rafraichir(); }
			public void mouseMoved(MouseEvent arg0) { rafraichir(); }
		});
	    txtRecherche.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent e)
			{
				if (txtRecherche.getText().equals("Recherche")) txtRecherche.setText("");
				rafraichir();
			}
			public void mouseEntered(MouseEvent e) { rafraichir(); }
			public void mouseExited(MouseEvent e) { rafraichir(); }
			public void mousePressed(MouseEvent e) { rafraichir(); }
			public void mouseReleased(MouseEvent e) { rafraichir(); }
		});
		
	    //panRecherche.add(txtRecherche);
	    //panRecherche.add(btnRecherche);
	    
	    
	    txtRecherche.setFont(Panneau.POLICE24);
	    txtRecherche.setBackground(new Color(0,0,0,0));
	    //panRecherche.setBorder(new LineBorder(new Color(100,100,100),2));
	    txtRecherche.setBorder(BorderFactory.createEmptyBorder());
	    gbc.fill = GridBagConstraints.BOTH;
	    //gbc.insets = new Insets(20, 20, 0, 20);
	    gbc.weightx = 1;
	    add(txtRecherche, gbc);
	    //add(panRecherche, gbc);
	    
	    //gbc.insets = new Insets(20, 0, 0, 20);
	    //gbc.fill = GridBagConstraints.NONE;
	    gbc.gridx = 1;
	    gbc.weightx = 0;
	    //btnRecherche.setBackground(new Color(220,230,235));
	    //btnRecherche.setFont(Interface.POLICE24);
	    add(btnRecherche, gbc);
	    btnRecherche.setMargin(new Insets(2,5,2,4));
    }
}
