package package_vue;



import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;
import java.util.ArrayList;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.border.LineBorder;

import package_controleur.Controleur;
import package_modele.Fichier;
import package_modele.Tag;

@SuppressWarnings("serial")
public class Vue extends JFrame implements PropertyChangeListener
{
	public static final String PROPERTY_RECENTS = "recents";
	public static final String PROPERTY_RECENTS_TAGS = "recents_tags";
	public static final String PROPERTY_LISTING = "listing";
	public static final String PROPERTY_LISTING_TAGS = "listing_tags";
	public static final String PROPERTY_LISTING_FICHIERS = "listing_fichiers";
	public static final String PROPERTY_AJOUT_FICHIERS = "ajout_fichiers";
	public static final String PROPERTY_RECHERCHE_AJOUT = "recherche_ajout";
	public static final String PROPERTY_NEWTAG = "newtag";
	
	
	
    private Controleur controleur;
    protected GridBagConstraints gbc = new GridBagConstraints();
    
    public PanneauRecherche panneauRecherche;
    public PanneauTagsRecents panneauTagsRecents;
    public PanneauListing panneauListing;
    public PanneauAjoutFichiers panneauAjoutFichiers;
    private NewTag newtag;
    
    public Vue(Controleur c)
    {
		controleur = c;
		panneauRecherche = new PanneauRecherche(controleur);
		panneauTagsRecents = new PanneauTagsRecents(controleur);
		panneauListing = new PanneauListing(controleur);
		panneauAjoutFichiers = new PanneauAjoutFichiers(controleur);
		newtag = new NewTag(controleur);
		
		setTitle("Organidocs");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setVisible(true);
		setSize(640, 720);


        
        
        setContentPane(new PanneauPrincipal());
	    //getContentPane().setBackground(Color.BLACK);
	    gbc.weightx = 1;
	    gbc.fill = GridBagConstraints.HORIZONTAL;
	    gbc.gridy = 0;
	    
	    panneauRecherche.setBorder(new LineBorder(new Color(100,100,100),2));
	    gbc.insets = new Insets(30, 20, 0, 20);
	    add(panneauRecherche, gbc);
	    gbc.insets = new Insets(30, 0, 0, 0);
	    gbc.gridy++;
	    add(panneauTagsRecents, gbc);
	    gbc.gridy++;
	    //gbc.anchor = GridBagConstraints.FIRST_LINE_START;
	    add(panneauListing, gbc);
	    gbc.gridy++;
	    gbc.weighty = 1;
	    gbc.fill = GridBagConstraints.BOTH;
	    gbc.anchor = GridBagConstraints.PAGE_START;
	    //panneauAjoutFichiers.setBackground(Color.BLACK);
	    add(panneauAjoutFichiers, gbc);
	    
	    gbc.fill = GridBagConstraints.NONE;
	    gbc.gridy++;
	    gbc.weighty = 0;
	    
	    //gbc.insets = new Insets(0, 0, 0, 0);
	    gbc.anchor = GridBagConstraints.LINE_END;
	    gbc.insets.right = 15;
	    add(new JLabel(new ImageIcon("logo.png")), gbc);
    }


	@Override
	public void propertyChange(PropertyChangeEvent ev)
	{
		if (ev.getPropertyName().equals(PROPERTY_RECENTS))
		{
			panneauTagsRecents.setVisible(true);
			panneauListing.setVisible(false);
		}
		if (ev.getPropertyName().equals(PROPERTY_LISTING))
		{
			panneauTagsRecents.setVisible(false);
			panneauListing.setVisible(true);
		}
		if (ev.getPropertyName().equals(PROPERTY_RECENTS_TAGS))
		{
			panneauTagsRecents.vider();
			for (Tag tag : (ArrayList<Tag>)ev.getNewValue()) { panneauTagsRecents.ajouter(tag.getnomTag(), tag.getColor()); }
		}
		if (ev.getPropertyName().equals(PROPERTY_LISTING_TAGS))
		{
			panneauListing.panneauTags.vider();
			for (Tag tag : (ArrayList<Tag>)ev.getNewValue()) { panneauListing.panneauTags.ajouter(tag.getnomTag(), tag.getColor()); }
		}
		
		if (ev.getPropertyName().equals(PROPERTY_AJOUT_FICHIERS))
		{
			panneauAjoutFichiers.vider();
			for (Fichier fichier : (ArrayList<Fichier>)ev.getNewValue()) { panneauAjoutFichiers.ajouter(fichier.file, fichier.nom, fichier.date, fichier.taille); }
		}
		if (ev.getPropertyName().equals(PROPERTY_LISTING_FICHIERS))
		{
			panneauListing.panneauFichiers.vider();
			for (Fichier fichier : (ArrayList<Fichier>)ev.getNewValue()) { panneauListing.panneauFichiers.ajouter(fichier.nom, fichier.date, fichier.taille); }
		}
		if (ev.getPropertyName().equals(PROPERTY_RECHERCHE_AJOUT))
		{
			String newRecherche = ""+ev.getNewValue();
			panneauRecherche.txtRecherche.setText(newRecherche);
			controleur.rechercher(newRecherche);
		}
		if (ev.getPropertyName().equals(PROPERTY_NEWTAG))
		{
			newtag.fichier = (File) ev.getNewValue();
			newtag.setVisible(true);
		}
	}
}
